#pragma semicolon 1

#include <sourcemod>
#include <tf2_stocks>

public Plugin myinfo =
{
	name = "Infinite Hype",
	author = "Shadow Mario | blw.tf",
	description = "Infinite Soda Popper and Baby's Face Blaster Hype/Boost",
	version = "1.0",
	url = "http://steamcommunity.com/id/shadowmariobr/"
}

stock int GetIndexOfWeaponSlot(client, slot)
{
	new weapon = GetPlayerWeaponSlot(client, slot);
	return (weapon > MaxClients && IsValidEntity(weapon) ? GetEntProp(weapon, Prop_Send, "m_iItemDefinitionIndex") : -1);
}

bool IsValidClient(int client)
{
	return client > 0 && client <= MaxClients && IsClientConnected(client)
	&& !IsFakeClient(client) && IsClientInGame(client)
	&& !GetEntProp(client, Prop_Send, "m_bIsCoaching")
	&& !IsClientSourceTV(client) && !IsClientReplay(client);
}

public void OnGameFrame()
{
	for(int client = 1; client <= MaxClients; client++)
	{
		if(!IsValidClient(client) || !IsPlayerAlive(client))
		{
			return Plugin_Stop;
		}
		
		new TFClassType:class = TF2_GetPlayerClass(client);
		int weapon = GetIndexOfWeaponSlot(client, TFWeaponSlot_Melee);
		if (IsClientInGame(client) && IsPlayerAlive(client))
		{
			if (class == TFClass_Scout && weapon == 448 || weapon == 772)
			{
				SetEntPropFloat(client, Prop_Send, "m_flHypeMeter", 100.0);
			}
		}
	}
	
	return Plugin_Continue;
}
